{% extends 'base.html.twig' %}

{% block body %}
    <main class='main-content bgc-grey-100'>
        <div id='mainContent'>
            <div class="row my-3">
                <div class="col px-3 ">
                    <a href="{{ path('group_providers_list') }}" class="btn btn-info btn-arrow-right btn-arrow-start mb-2">
                        Studenti
                    </a>
                    {% if currentSectorName == "" %}
                        <a href="#" class="btn btn-success btn-arrow-right mb-2">
                            {{ provider.name|capitalize }}
                        </a>
                    {% else %}
                        <a href="{{ path('list_groups_in_provider', {'providerId': provider.id}) }}"
                           class="btn btn-info btn-arrow-right mb-2">
                            {{ provider.name|capitalize }}
                        </a>
                        <a href="#" class="btn btn-success btn-arrow-right mb-2">
                            {{ currentSectorName|capitalize }}
                        </a>
                    {% endif %}
                </div>
                <div class="col-auto">
                    <ul class="list-unstyled">
                        <li>
                            <i class="fa-solid fa-globe"></i> Navigazione attiva per tutto il gruppo &nbsp;
                        </li>
                        <li>
                            <i class="fa fa-users"></i> Sono presenti utenti con navigazione singola attiva &nbsp;
                        </li>
                        <li>
                            <i class="fa-solid fa-mobile-screen"></i> Sono permessi dispositivi personali
                        </li>
                    </ul>
                </div>
            </div>


            {% if sectorsList and not sectorsList.empty %}
                <ul class="nav nav-tabs">
                    {% for sector in sectorsList %}
                        <li class="nav-item">
                            <a class="nav-link {{ sector.id == currentSectorId ? 'active' : '' }}" href="{{ path('list_groups_in_provider', {'providerId': provider.id}) }}?sectorId={{ sector.id }}">{{ sector.name }}</a>
                        </li>
                    {% endfor %}
                </ul>
            {% endif %}


            <div class="table-responsive">
                <table class="table table-striped">

                    {% set listDivider = '' %}
                    {% for group in groups %}
                        {% if group.name|length>1 %}
                            {% if group.name|upper|slice(0, 1) != listDivider %}
                                {% set listDivider = group.name|upper|slice(0, 1) %}
                                <tr class="info">
                                    <td colspan="3" align="center">{{ listDivider }}</td>
                                </tr>
                            {% endif %}
                        {% endif %}
                        <tr>
                            <td>
                                {% if group.state=='group-active' %}
                                    <i class="fa-solid fa-globe"></i>
                                {% endif %}
                                {% if group.state=='user-active' %}
                                    <i class="fa fa-users"></i>
                                {% endif %}
                                {% if group.permitPersonalDevices %}
                                    <i class="fa-solid fa-mobile-screen"></i>
                                {% endif %}
                                {% if group.endingTime %}
                                    {{ group.endingTime }}
                                {% endif %}
                                {% if group.activedBy != "" %}<br/>

                                    <span class="badge text-bg-success lh-0 p-10">{{ group.activedBy }}</span>

                                {% endif %}
                            </td>
                            <td>{{ group.name }}</td>
                            <td class="align-middle">
                                <div class="d-flex h-100 align-items-center justify-content-end gap-2">
                                    {% if group.state!='group-active' and group.state != 'activating' %}
                                        <button id="internetOn-{{ group.id }}" data-group-name="{{ group.name }}"
                                                class="btn btn-success internetOn">
                                            Attiva
                                        </button>
                                    {% endif %}
                                    {% if group.state=='group-active' %}
                                        <button id="internetEx-{{ group.id }}" data-group-name="{{ group.name }}"
                                                class="btn btn-warning internetOn">
                                            Estendi
                                        </button>
                                        <a href="{{ path('internetOff',{'providerId': provider.id,'groupId':group.id}) }}{% if currentSectorId %}?sectorId={{ currentSectorId }}{% endif %}"
                                           class="btn btn-danger"
                                                {% if group.activedByOtherUser %} onclick="return confirm('Non sei stato tu ad abilitare questa classe. Sicuro di volerla disattivare?')"{% endif %}
                                        >
                                            Disattiva
                                        </a>
                                    {% elseif group.state=='activating' %}
                                        <span class="badge bg-warning align-self-center">In Attivazione</span>
                                    {% endif %}
                                    <a href="{{ path('list_students_in_group',{'groupId':group.id, 'providerId': provider.id}) }}"
                                       class="btn {% if group.state=='user-active' %}btn-danger{% else %}btn-secondary{% endif %}">
                                        Studenti
                                    </a>
                                </div>
                            </td>
                        </tr>

                    {% endfor %}
                </table>
            </div>


            <div class="modal fade" id="setTime" tabindex="-1" aria-labelledby="setTime" aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Attivazione internet</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">

                            <div class="mb-3">
                                <label for="timeToSet" class="form-label">
                                    Attiva <span id="setTimeGroup"></span> fino alle:
                                </label>
                                <input type="time" class="form-control" id="timeToSet"
                                       value="{{ timeToSet|date('H:i') }}"
                                       title="Orario di attivazione, nel formato HH:MM">
                            </div>
                            {% if userCanEnablePersonalDevice %}
                                <div class="form-check">
                                    <input class="form-check-input" type="checkbox" value="1" id="permitPersonalDevice">
                                    <label class="form-check-label" for="permitPersonalDevice">
                                        Permetti dispositivi personali
                                    </label>
                                </div>
                                <div id="permitPersonalDeviceMsg" style="display: none" class="alert alert-warning" role="alert">
                                    <small>NB: Attenzione! Questa opzione rallenta il wifi in classe!<br/>Da
                                        usare solo
                                        per attività nelle quali è necessario l'utilizzo dei cellulari e pc
                                        portatili
                                        degli studenti sulla rete {{ wifiSsid }}.
                                    </small>
                                </div>
                            {% endif %}
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Chiudi</button>
                            <button id="setTimeConfirm" type="button" class="btn btn-primary">Invia</button>
                        </div>
                    </div>
                </div>
            </div>


            <div class="row">
                <div class="col-lg-6 col-md-12 col-sm-12 d-grid gap-2 d-lg-flex align-items-center mb-2">
                    <a href="{{ path('group_providers_list') }}" class="btn btn-secondary mb-2">
                        Ritorna alla lista
                    </a>
                </div>
                <div class="col-lg-6 col-md-12 col-sm-12 d-grid gap-2 d-lg-flex justify-content-lg-end text-start text-md-end align-items-center mb-2">
                    {% if currentUserIsAdmin %}
                        <a href="{{ path('group_new', {'providerId': provider.id}) }}" class="btn btn-primary">Crea Gruppo</a>
                    {% endif %}
                </div>
            </div>
        </div>
    </main>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script type="text/javascript">
        $(function ($) {
            var groupId = '';
            var timeToSet = '{{ timeToSet|date("H:i") }}';
            var setTimeModal = $("#setTime");
            var timeToSetInput = $('#timeToSet');
            var setTimeConfirmBt = $("#setTimeConfirm");
            var permitPersonalDeviceInput = $('#permitPersonalDevice');
            var permitPersonalDeviceMsg = $('#permitPersonalDeviceMsg');
            var internetOnBaseUrl = "{{ path('internetOn',{'providerId': provider.id, 'groupId': '%groupId' }) }}?{% if currentSectorId %}sectorId={{ currentSectorId }}&{% endif %}";
            var activatedPollingUrl = "{% if activatedGroup != "" %}{{ path('internetIsOn',{'providerId': provider.id, 'groupId': activatedGroup }) }}{% endif %}";
            var activatedPoolingRetryTimes = 0;

            console.log("timeToSetInput", timeToSetInput);

            $(".internetOn").click(function () {
                groupId = $(this).attr("id").substring(11);
                $('#setTimeGroup').html($(this).data('group-name'));
                setTimeModal.modal('show');
            });

            setTimeModal.on("shown.bs.modal", function (e) {
                timeToSetInput.focus();
            });

            timeToSetInput.on("keydown", function (e) {
                if (e.which === 13) {
                    e.preventDefault();
                    setTimeConfirmBt.click();
                } else if (e.which === 32) {
                    e.preventDefault();
                    permitPersonalDeviceInput.click();
                }
            });

            permitPersonalDeviceInput.on("keydown", function (e) {
                if (e.which === 13) {
                    e.preventDefault();
                    setTimeConfirmBt.click();
                }
            });

            setTimeConfirmBt.click(function () {
                if (timeToSetInput.val() !== "")
                    timeToSet = timeToSetInput.val();
                window.location.href = internetOnBaseUrl.replace("%25groupId", groupId) + "timeToSet=" + timeToSet + "&personalDevice=" + (permitPersonalDeviceInput.is(':checked') ? "1" : "0");
                setTimeModal.modal('hide');
            });

            permitPersonalDeviceInput.click(function () {
                if (permitPersonalDeviceInput.is(':checked')) {
                    permitPersonalDeviceMsg.show();
                } else {
                    permitPersonalDeviceMsg.hide();
                }
            });

            var activatedPolling = function () {
                $.get(activatedPollingUrl, function (data) {
                    if (data.error === undefined && data.on === true && data.activationCompleted === true) {
                        window.location.reload();
                    }

                    if (++activatedPoolingRetryTimes < 10) {
                        setTimeout(activatedPolling, 1500);
                    }
                });
            };

            if (activatedPollingUrl !== "") {
                setTimeout(activatedPolling, 1500);
            }
        });
    </script>



{% endblock %}
